#include "stdafx.h"
#include "TestApplication.h"
#include "TestApplicationDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

CTestApplicationDlg::CTestApplicationDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CTestApplicationDlg::IDD, pParent)
    , m_log("log.txt")
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
    m_log<<"The number of rectangles that make up the region of the main window\n";
}

void CTestApplicationDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CTestApplicationDlg, CDialog)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


BOOL CTestApplicationDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

    m_windowObserver.reset(new wrm::CWinRegionObserver((HWND)m_hWnd, this, this));
    return TRUE;  // return TRUE  unless you set the focus to a control
}

void CTestApplicationDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

HCURSOR CTestApplicationDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

void CTestApplicationDlg::WinEventNotify( const _RGNDATA *data )
{
    m_log<<data->rdh.nCount<<std::endl;
}

void CTestApplicationDlg::OnWinEventError( __in const char * msg)
{
    m_log<<msg<<std::endl;
}