#include "stdafx.h"

std::string FormatError( DWORD status, DWORD dwLanguageId /*= MAKELANGID(LANG_ENGLISH,SUBLANG_ENGLISH_US)*/ )
{
    LPVOID lpMsgBuf;
    if (DWORD dwSize = FormatMessageA(
        FORMAT_MESSAGE_ALLOCATE_BUFFER |
        FORMAT_MESSAGE_FROM_SYSTEM |
        FORMAT_MESSAGE_IGNORE_INSERTS,
        NULL,
        status,
        dwLanguageId, // Default language
        (LPSTR) &lpMsgBuf,
        0,
        NULL ))
    {
        boost::shared_ptr<void> guard(lpMsgBuf, &LocalFree);
                
        if(dwSize < 2)
            return "";

        return std::string((char*)lpMsgBuf, (char*)lpMsgBuf + dwSize - 2);
    }
    else
    {
        return (boost::format("Can't format message from error code = %1%")%status).str();
    }
}