#pragma once

#include <boost/thread.hpp>
#include <boost/shared_ptr.hpp>

namespace wrm
{

struct IWinRegionObserver;
struct IErrorObserver;

class CWinRegionObserver
{
public:
    CWinRegionObserver(HWND hWnd, IWinRegionObserver * pEventObserver,  IErrorObserver* pErrorObserver, DWORD TimeOut = 200);
    ~CWinRegionObserver();

    HWND GetHWND();

private:
    unsigned int NotifyThread();
    void Notify();
    void NotifyZero();
    
private:
    HWND m_window;
    boost::shared_ptr<void> m_oldRgn;
    const DWORD m_timeout;
    bool m_stopping;
    boost::thread m_watcherThread;

    IWinRegionObserver* m_regionObserver;
    IErrorObserver* m_errorObserver;
};

}