#ifndef _WINEVENTOBSERVER_H_INCLUDED_
#define _WINEVENTOBSERVER_H_INCLUDED_

struct _RGNDATA;

namespace wrm
{

struct IWinRegionObserver
{
    virtual ~IWinRegionObserver(){}
    virtual void WinEventNotify(const _RGNDATA *) = 0;
};

struct IErrorObserver
{
    virtual ~IErrorObserver(){}
    virtual void OnWinEventError(__in const char *) = 0;
};

#define BEGIN_WEH_EXCEPTION_SAFE_BLOCK try

#define END_WEH_EXCEPTION_SAFE_BLOCK(__observer_ptr) \
catch(const std::exception& exc)\
{\
    __observer_ptr->OnWinEventError(exc.what());\
    return 0;\
}\
catch(...)\
{\
    __observer_ptr->OnWinEventError(__FUNCTION__" - unknown error");\
    return 0;\
}


}//weh

#endif //_WINEVENTOBSERVER_H_INCLUDED_